LOCALS

DATA SEGMENT PUBLIC

extrn VesaInfo:DWord
extrn ModeInfo:DWord
extrn VideoSeg:Word;
extrn SwitchAddr:DWord;
extrn CurrBank:Word;
extrn CurrLogScan:Word;
extrn CurrLogScanBits:Byte;

DATA ENDS

CODE SEGMENT PUBLIC

ASSUME cs:CODE,ds:DATA

.386

PUBLIC GetVesaInfo
PUBLIC GetModeInfo
PUBLIC SwitchTo
PUBLIC InitVesaMode
PUBLIC InitTextMode
PUBLIC SetLogScan
PUBLIC SetDisplayXY
PUBLIC PutPixel8
PUBLIC PutPixel32
PUBLIC GetPixel8

GetVesaInfo PROC Pascal Far

mov ah,4fh
mov al,00h
mov bx,ds
mov es,bx
lea di,VesaInfo
int 10h
ret

ENDP

GetModeInfo PROC Pascal Far ModeNr:Word

mov ah,4fh
mov al,01h
mov cx,ModeNr
mov bx,ds
mov es,bx
lea di,ModeInfo
int 10h
ret

ENDP

SwitchTo PROC Pascal Far BankNr:Word

mov dx,BankNr
cmp dx,CurrBank
je @@Skip
mov CurrBank,dx
mov bh,00h
mov bl,00h                           ;01h fr Window B
call dword ptr [SwitchAddr]
@@Skip:
ret

ENDP

InitVesaMode PROC Pascal Far ModeNr:Word

mov ah,4fh
mov al,02h
mov bx,ModeNr
int 10h
mov CurrBank,0ffffh
push word ptr 0000h
call SwitchTo
ret

ENDP

InitTextMode PROC Pascal Far

mov ax,0003h
int 13h
ret

ENDP

SetLogScan PROC Pascal Far NewLength:Word

mov ah,4fh
mov al,06h
mov bl,00h                           ;01h fr GetLogScan
mov cx,NewLength
mov CurrLogScan,cx
int 10h
ret

ENDP

SetDisplayXY PROC Pascal Far X:Word,Y:Word

mov ah,4fh
mov al,07h
mov bh,00h
mov bl,00h
mov cx,X
mov dx,Y
int 10h
ret

ENDP

PutPixel8 PROC Pascal Far X:Word,Y:Word,Col:Byte

mov eax,dword ptr Y                  ;Calc. ScrOfs: X+Y*XRes
mov cl,CurrLogScanBits
shl eax,cl
add eax,dword ptr X

mov di,ax                            ;Calc. BankOfs: ScrOfs mod WinGran
shr eax,16                           ;Calc. BankNb: ScrOfs div WinGran

push ax                              ;SwitchBank
call SwitchTo

mov ax,VideoSeg                      ;Lade VideoSeg
mov es,ax

mov al,Col                           ;Setze Farbe
mov es:[di],al
ret

ENDP

PutPixel32 PROC Pascal Far X:Word,Y:Word,Col:DWord

mov eax,dword ptr Y                  ;Calc. ScrOfs: (X+Y*XRes)*4
mov cl,CurrLogScanBits
shl eax,cl
add eax,dword ptr X
shl eax,2

mov di,ax                            ;Calc. BankOfs: ScrOfs mod WinGran
shr eax,16                           ;Calc. BankNb: ScrOfs div WinGran

push ax                              ;SwitchBank
call SwitchTo

mov ax,VideoSeg                      ;Lade VideoSeg
mov es,ax

mov eax,Col                          ;Setze Farbe
mov es:[di],eax
ret

ENDP

GetPixel8 PROC Pascal Far X:Word,Y:Word

mov eax,dword ptr Y                  ;Calc. ScrOfs: X+Y*XRes
mov cl,CurrLogScanBits
shl eax,cl
add eax,dword ptr X

mov di,ax                            ;Calc. BankOfs: ScrOfs mod WinGran
shr eax,16                           ;Calc. BankNb: ScrOfs div WinGran

push ax                              ;SwitchBank
call SwitchTo

mov ax,VideoSeg                      ;Lade VideoSeg
mov es,ax

mov al,es:[di]                       ;Hole Farbe
ret

ENDP

CODE ENDS
END
